using System;
using Zcu.Mve.Core;
using System.Diagnostics;

namespace Zcu.Mve.Elementals
{
    /// <summary>
    /// Module prints content of a data structure to the standatd output.
    /// It uses the method ToString().
    /// </summary>
    [ModuleInfo("Milan Frank",
      "Module prints content of a data structure to the standatd output.",
      CategoryType.Output,
      CategoryData.Generic,
       Assemblied = "2004-08-26",
       IconName = "Console.ico",
       Category = "Output")]

    [PortInfo("input", "Data to be printed.")]
    public class ConsolePrinter : Zcu.Mve.Core.Module
    {
        /// <summary>
        /// Constructor add input port.
        /// </summary>
        public ConsolePrinter()
        {
            this.AddInPort("input", typeof(Zcu.Mve.Core.IDataObject));
        }

        /// <summary>
        /// Prints data coming to the input port.
        /// </summary>
        public override void Execute()
        {
            Console.WriteLine(this.Name + ": \r\n" + this.GetInput("input").ToString());
        }
    } //ConsolePrinter

} //namespace

