using System;
using Zcu.Mve.Core;

namespace Zcu.Mve.Elementals
{
	/// <summary>
	/// Module checks a data consistence by calling of the method CheckConsistence of data object.
	/// This method is declared in the Core's interface IDataObject.
	/// </summary>
  [ModuleInfo("Milan Frank",
    "Module checks a data consistence by calling the CheckConsistence method" +
    "of data object.",
    CategoryType.Output, CategoryData.Generic,
    Assemblied = "2004-08-26", IconName = "Goofy.ico")]

  [PortInfo("Input", "checking data")]	
  
  public class DataChecker : Zcu.Mve.Core.Module
	{
		/// <summary>
		/// Constructor adds input port.
		/// </summary>
    public DataChecker()
		{
      this.AddInPort("Input", typeof (Zcu.Mve.Core.IDataObject));
		}

    /// <summary>
    /// Method checks constistence.
    /// </summary>
    public override void Execute()
    {
      IDataObject data = GetInput("Input");
      if (data.CheckConsistence())
      {
        Console.WriteLine(this.Name + ": Data are consistent. Possible warnigs are written above.");
      }
      else
      {
        Console.WriteLine(this.Name + ": Data are inconsistent. Reason and possible warnigs are written above.");
      }
    }

  } //DataChecker
}
