﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Runtime.InteropServices;

using Zcu.Mve.Core;

namespace Zcu.Mve.Numerics
{
    public class FileCount : Module
    {
		private string _dirName = ".";
		private bool _reload = false;

		private Integer _res = -1;

		[Editor(typeof(System.Windows.Forms.Design.FolderNameEditor), typeof(System.Drawing.Design.UITypeEditor))]
		public string DirName
		{
			get { return _dirName; }
            set { _dirName = value; }
		}

		public bool Reload
		{
			get { return _reload; }
			set { _reload = value; }
		}


        public FileCount()
		{
            AddOutPort("FileCount", typeof(Integer));
		}

        public override void Execute()
        {
            if (!_reload && IsAllUserSettingsSame() && _res >= 0)
            {
                SetOutput("FileCount", _res, true);
            }
            else
            {
                _res = Directory.GetFiles(Path.GetFullPath(_dirName)).Length;
                SetOutput("FileCount", _res, false);
            }
        }
    }
}
