using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Numerics
{
    class Round:Module
    {
        public Round()
        {
            AddInPort("Scalar", typeof(Scalar));
            AddOutPort("Integer", typeof(Integer));
        }

        Integer result = 0;

        public override void Execute()
        {
            if (!IsAllDataSame())
            {
                Scalar input = (Scalar)GetInput("Scalar");
                int rounded = (int)Math.Round(input.Value);
                result = new Integer(rounded);
                SetOutput("Integer", result);
            }
            else
            {
                SetOutput("Integer", result, true);
            }
        }
    }
}
