﻿using System;
using System.Collections.Generic;
using System.Text;

using Zcu.Mve.Core;

namespace Zcu.Mve.Numerics
{
    [ModuleInfo("Oldřich Petřík", "Modul for calculating absolute value of a Scalar", CategoryType.Filter, CategoryData.Number)]
    [PortInfo("Arg", "First argument")]
    [PortInfo("Result", "Result of the Abs operation")]
    class ScalarAbsoluteValue : Zcu.Mve.Core.Module
    {
        /// <summary>
        /// result kept for the next run of the module
        /// </summary>
        private Scalar result;

        /// <summary>
        /// Adds module input and output ports.
        /// </summary>
        public ScalarAbsoluteValue()
        {
            AddInPort("Arg", typeof(Scalar));
            AddOutPort("Result", typeof(Scalar));
        }

        /// <summary>
        /// Performs the multiplication. If no inputs were chnaged since the last run, 
        /// then the last result is returned immediately with the DataSame flag set.
        /// </summary>
        public override void Execute()
        {
            if (IsAllDataSame() && IsAllUserSettingsSame())
            {
                this.WriteDebug("Skip execution", "nothing changed");
                this.ProgressInfo(1);
                SetOutput("Result", result, true);
            }
            else
            {
                Scalar a = (Scalar)GetInput("Arg");
                result = Math.Abs(a);
                this.ProgressInfo(1);
                SetOutput("Result", result);
            }
        }
    }
}
