using System;
using Zcu.Mve.Numerics;
using Zcu.Mve.Core;

namespace Zcu.Mve.Testing
{
    /// <summary>
    /// Position renderer.
    /// </summary>
    [ModuleInfo("Milan Frank", "Modul vykresl 2D vektory v kartzskch souadnicch jako kruh. Zobraziteln rozsah je <-1, 1>", CategoryType.Output, CategoryData.Number)]
    [PortInfo("A", "prvn pozice")]
    [PortInfo("B", "druh pozice")]
    public class PositionRenderer : Zcu.Mve.Core.Module
    {
        internal Vector2D pos1 = new Vector2D(0.0, 0.0);
        internal Vector2D pos2 = new Vector2D(0.0, 0.0);
        private PositionRendererPanel panel;

        /// <summary>
        /// construct an instance of the module, adds ports.
        /// </summary>
        public PositionRenderer()
        {
            this.SimulationStarted += new SimulationStartedEventHandler(SimStart);
            AddInPort("A", typeof(Vector2D), false);
            AddInPort("B", typeof(Vector2D), false);
            panel = new PositionRendererPanel(this);
        }

        /// <summary>
        /// Shows the window at the simulation start.
        /// </summary>
        /// <param name="source">event source</param>
        public void SimStart(object source)
        {
            if (panel.IsDisposed)
            {
                panel = new PositionRendererPanel(this);
            }
            panel.Show();
        }

        /// <inheritdoc />
        public override void Execute()
        {
            pos1 = (Vector2D)GetInput("A");
            pos2 = (Vector2D)GetInput("B");

            if (panel.IsDisposed == false)
            {
                // panel.Invalidate();
                panel.Refresh();
            }
        }
    }
}
