using System;
using Zcu.Mve.Core;
using Zcu.Mve.Numerics;
using Zcu.Mve.Visualization;

namespace Zcu.Mve.Testing
{
    /// <summary>
    /// Sample filter which sets the first point of an UnstrGrid to position (10,0,0). Demonstration only, has many flaws.
    /// </summary>
    public class TestFilter : Zcu.Mve.Core.Module
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        public TestFilter()
        {
            AddInPort("in", typeof(UnstrGrid));
            AddOutPort("out", typeof(UnstrGrid));
        }

        /// <summary>
        /// Takes data from the input, sets the first point position to (10,0,0), sets it as output. Calls deepcopy.
        /// </summary>
        public override void Execute()
        {
            UnstrGrid x = (UnstrGrid)((UnstrGrid)GetInput("in")).DeepCopy();
            x.Points[0] = new Point3D(10.0, 0.0, 0.0);
            SetOutput("out", x);
        }
    }
}