using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using System.ComponentModel;
using System.Collections;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.GSVD
{

    /// <summary>
    ///Module only for testing purposes and added here only for testing of TestMap.mve. Generates new attribute named "Hodnoty" to input mesh.
    /// </summary>
    [ModuleInfo("Jan tefny", "")]
    [PortInfo("RegGridNDIN", "RegGridND")]
    [PortInfo("RegGridNDOut", "RegGridND")]
    public class TestModul : Zcu.Mve.Core.Module
    {
        #region Variables declaration

        private String atributeName;
        public String AtributeName
        {
            set { atributeName = value; }
            get { return atributeName; }
        }

        private bool valueChanged = false;
        public bool ValueChanged
        {
            set { valueChanged = value; }
        }

        private UnstrGrid outputGrid;
        #endregion

        /// <summary>
        /// Default constructor.
        /// </summary>
        public TestModul()
        {

            AddInPort("UnstrGridIN", typeof(UnstrGrid),true);
            AddOutPort("UnstrGridOut", typeof(UnstrGrid));
        }

        

        /// <summary>
        /// Entry point of module. By parameters choose CCL with or without preprocessing.
        /// </summary>
        public override void Execute()
        {
            if (!IsAllDataSame())
            {
                //List<ColorRGBA> polebarev = SamplePalet();

                ExecuteUnstrGrid();
                
            }
            else
            {
                SetOutput("UnstrGridOut", outputGrid, true);
            }
        }


        private void ExecuteUnstrGrid()
        {
            UnstrGrid inputUnstrGrid = (UnstrGrid)this.GetInput("UnstrGridIN");
            
            if (inputUnstrGrid == null)
            {
                //throw
                return;
            }
                      
                        CreateOutputUnstrGridFromUnstrGrid(inputUnstrGrid);
                        return;

        }


        private void CreateOutputUnstrGridFromUnstrGrid(UnstrGrid inputUnsterGrid)
        {
            List<Integer> colorsAr = new List<Integer>();

            outputGrid = inputUnsterGrid.ShallowCopy();
            Integer kuk = -100;
            for (int i = 0; i < outputGrid.Points.Count; i++)
            {
                colorsAr.Add(kuk);
                kuk++;
            }

            outputGrid.AddPointAttrs("Hodnoty", UniformDataArray.FromList(colorsAr));

            SetOutput("UnstrGridOut", outputGrid);
        }
        public override ModuleSetup InvokeSetup()
        {
            return new PaletteGUI();
        }
    }
}


