﻿using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;

namespace Zcu.Mve.Visualization.Processing
{
    class SeparateAttribute : Module
    {
        public SeparateAttribute()
        {
            AddInPort("UnstrGrid", typeof(UnstrGrid));
            AddOutPort("Attribute", typeof(UniformDataArray));
        }

        bool cellAttribute = false;

        public bool CellAttribute
        {
            get { return cellAttribute; }
            set { cellAttribute = value; }
        }

        string attributeName = "attribute";

        public string AttributeName
        {
            get { return attributeName; }
            set { attributeName = value; }
        }

        string cellsName = "triangles";

        public string CellsName
        {
            get { return cellsName; }
            set { cellsName = value; }
        }

        UniformDataArray result = null;

        public override void Execute()
        {
            if (IsAllDataSame() && IsAllUserSettingsSame())
            {
                SetOutput("Attribute", result, true);
            }
            UnstrGrid input = (UnstrGrid)GetInput("UnstrGrid");
            if (cellAttribute)
            {
                result = input.GetCellAttrs(cellsName, attributeName);
            }
            else
                result = input.GetPointAttrs(attributeName);
            SetOutput("Attribute", result);
        }
    }
}
