using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;

namespace Zcu.Mve.Visualization.Processing
{
    [ModuleInfo("Libor Va", "Module checks user tags assigned with a dataSet. Found user tags are printed to console.", CategoryType.Generic, CategoryData.Generic, IconName = "Goofy.ico")]
    [PortInfo("Input dataset", "DataSet instance to be checked. Only Visualisation.DataSet instances have user tags.")]
    class UserTagChecker:Module
    {
        public UserTagChecker()
        {
            AddInPort("Input dataset", typeof(DataSet));
        }

        public override void Execute()
        {
            DataSet input = (DataSet)GetInput("Input dataset");
            foreach (string key in input.UserTags.Keys)
            {
                Console.WriteLine(key + ": " + input.UserTags[key].ToString());
            }
        }
    }
}
