//using System;
//using System.IO;

//using Zcu.Mve.Numerics;

//namespace Zcu.Mve.Visualization.Loaders
//{
//    /// <summary>
//    /// Read volume data from .vol file.
//    /// </summary>
//    internal class Vol
//    {
//        /// <summary>
//        /// Minimum value of loaded volume data.
//        /// </summary>
//        private double _min;

//        /// <summary>
//        /// Maximum value of loaded volume data.
//        /// </summary>
//        private double _max;

//        /// <summary>
//        /// Volume data.
//        /// </summary>
//        private Mve.Visualization.MveArray _data;

//        /// <summary>
//        /// Handle to progress bar
//        /// </summary>
//        private VolLoader.ProgressInfoChangedEventHandler _barHandler;

//        /// <summary>
//        /// Constructor.
//        /// </summary>
//        /// <paramsChanged name="br">file data source</paramsChanged>
//        /// <paramsChanged name="vif">description of .vol file</paramsChanged>
//        /// <paramsChanged name="barHandler">handle to progress bar</paramsChanged>
//        public Vol(BinaryReader br, Vif vif, VolLoader.ProgressInfoChangedEventHandler barHandler)
//        {
//            _barHandler = barHandler;

//            _data = new Mve.Visualization.MveArray(typeof(Integer), (int)vif.Resolution.X, (int)vif.Resolution.Y, (int)vif.Resolution.Z);

//            br.ReadBytes(vif.HeaderSize); // skip header

//            barHandler(this, 0.0f);

//            switch (vif.BytesPerVoxel)
//            {
//                case 1:
//                    LoadAsByte(br);
//                    break;

//                case 2:
//                    LoadAsShort(br, vif);
//                    break;

//                case 4:
//                    LoadAsInt(br, vif);
//                    break;

//                default:
//                    throw new FormatException("Unsupported volume data type.");
//            }

//            Zcu.Mve.Visualization.Processing.IsoSurfaceExtractor.GCClean();
//        }

//        #region Data load

//        /// <summary>
//        /// Method load data as byte. This mean data have size 1 bytes per voxel.
//        /// </summary>
//        /// <paramsChanged name="br">volume data source</paramsChanged>
//        private void LoadAsByte(BinaryReader br)
//        {
//            Integer[, ,] data = (Integer[, ,])_data.Array;

//            int bufferLength = _data.Lengths[0];

//            // local buffer from stream data reading
//            byte[] buffer = new byte[bufferLength];

//            long index = 0;
//            byte min = Byte.MaxValue;
//            byte max = Byte.MinValue;
//            byte h;
//            double progress = 1.0 / _data.Lengths[2];

//            unsafe
//            {
//                // 3D array is stored as 1D array
//                fixed (Integer* dataPtr = &data[0, 0, 0])
//                {
//                    for (int i = 0; i < _data.Lengths[2]; i++)
//                    {
//                        for (int j = 0; j < _data.Lengths[1]; j++)
//                        {
//                            // local buffer
//                            buffer = br.ReadBytes(bufferLength);

//                            // copy buffer into data
//                            for (int k = 0; k < bufferLength; k++)
//                            {
//                                h = buffer[k];

//                                min = min > h ? h : min;
//                                max = max < h ? h : max;

//                                dataPtr[index++] = (Integer)h;
//                            }
//                        }
//                        _barHandler.Invoke(this, (i + 1) * progress);
//                    }
//                }
//            }

//            // maximum and minimum values from data set
//            _max = max;
//            _min = min;
//        }

//        /// <summary>
//        /// Method load data as short. This mean data have size 2 bytes per voxel.
//        /// </summary>
//        /// <paramsChanged name="br">volume data source</paramsChanged>
//        private void LoadAsShort(BinaryReader br, Vif vif)
//        {
//            Integer[, ,] data = (Integer[, ,])_data.Array;

//            int bufferLength = _data.Lengths[0] * sizeof(UInt16);
//            byte[] buffer = new byte[bufferLength];

//            long index = 0;
//            ushort umin = ushort.MaxValue;
//            ushort umax = ushort.MinValue;
//            ushort uh;
//            short min = short.MaxValue;
//            short max = short.MinValue;
//            short h;
//            double progress = 1.0 / _data.Lengths[2];

//            unsafe
//            {
//                // 3D array is stored as 1D array
//                fixed (Integer* dataPtr = &data[0, 0, 0])
//                {
//                    for (int i = 0; i < _data.Lengths[2]; i++)
//                    {
//                        for (int j = 0; j < _data.Lengths[1]; j++)
//                        {
//                            // local buffer
//                            buffer = br.ReadBytes(bufferLength);

//                            // copy buffer into data
//                            for (int k = 0; k < bufferLength; k += sizeof(UInt16))
//                            {
//                                if (vif.Signed)
//                                {
//                                    h = BitConverter.ToInt16(buffer, k);
//                                    min = min > h ? h : min;
//                                    max = max < h ? h : max;
//                                    dataPtr[index++] = (Integer)h;
//                                }
//                                else
//                                {
//                                    uh = BitConverter.ToUInt16(buffer, k);
//                                    umin = umin > uh ? uh : umin;
//                                    umax = umax < uh ? uh : umax;
//                                    dataPtr[index++] = (Integer)uh;
//                                }
//                            }
//                        }

//                        _barHandler.Invoke(this, (i + 1) * progress);
//                    }
//                }
//            }

//            if (vif.Signed)
//            {
//                _min = min;
//                _max = max;
//            }
//            else
//            {
//                _min = umin;
//                _max = umax;
//            }
//        }

//        /// <summary>
//        /// Method load data as int. This mean data have size 4 bytes per voxel.
//        /// </summary>
//        /// <paramsChanged name="br">volume data source</paramsChanged>
//        private void LoadAsInt(BinaryReader br, Vif vif)
//        {
//            Integer[, ,] data = (Integer[, ,])_data.Array;

//            int bufferLength = _data.Lengths[0] * sizeof(UInt32);
//            byte[] buffer = new byte[bufferLength];

//            long index = 0;
//            /* uint umin = uint.MaxValue;
//             uint umax = uint.MinValue;
//             uint uh;*/
//            int min = int.MaxValue;
//            int max = int.MinValue;
//            int h;
//            double progress = 1.0 / _data.Lengths[2];

//            unsafe
//            {
//                // 3D array is stored as 1D array
//                fixed (Integer* dataPtr = &data[0, 0, 0])
//                {
//                    for (int i = 0; i < _data.Lengths[2]; i++)
//                    {
//                        for (int j = 0; j < _data.Lengths[1]; j++)
//                        {
//                            // local buffer
//                            buffer = br.ReadBytes(bufferLength);

//                            // copy buffer into data
//                            for (int k = 0; k < bufferLength; k += sizeof(UInt32))
//                            {
//                                //if (vif.Signed)
//                                {
//                                    h = BitConverter.ToInt32(buffer, k);
//                                    min = min > h ? h : min;
//                                    max = max < h ? h : max;
//                                    dataPtr[index++] = (Integer)h;
//                                }
//                                /*else
//                                {
//                                    uh = BitConverter.ToUInt32(buffer, k);
//                                    umin = umin > uh ? uh : umin;
//                                    umax = umax < uh ? uh : umax;
//                                    dataPtr[index++] = (Integer)uh;
//                                }*/
//                            }
//                        }

//                        _barHandler.Invoke(this, (i + 1) * progress);
//                    }
//                }
//            }

//            //if (vif.Signed)
//            {
//                _min = min;
//                _max = max;
//            }
//            /*else
//            {
//                _min = umin;
//                _max = umax;
//            }*/
//        }
//        #endregion

//        #region Properties

//        /// <summary>
//        /// Loaded volume data.
//        /// </summary>
//        public Mve.Visualization.MveArray Data
//        {
//            get { return _data; }
//            set { _data = value; }
//        }

//        /// <summary>
//        /// Get maximal value in vol. data.
//        /// </summary>
//        public Scalar Max
//        {
//            get { return _max; }
//        }

//        /// <summary>
//        /// Get minimal value in vol. data.
//        /// </summary>
//        public Scalar Min
//        {
//            get { return _min; }
//        }

//        #endregion
//    }
//}
